#ifndef PIPER_H
#define PIPER_H

// prInit() return codes.
#define PRRC_OK                  0
#define PRRC_INVALIDPIPENAME     1
#define PRRC_NOTENOUGHMENORY     2
#define PRRC_SRVPIPECREATEERR    3
#define PRRC_INVALIDSRVPIPENAME  4
// Same names of client and server named pipes.
#define PRRC_NAMECOLLISION       5

// Codes for function PPRFNUSER.
#define PREVENT_CONNECTED        0
#define PREVENT_DISCONNECTED     1
#define PREVENT_INPUTLINE        2
#define PREVENT_PIPECREATEERROR  3
#define PREVENT_CONNECTERROR     4

typedef struct _PIPER *PPIPER;

typedef VOID (*PPRFNUSER)(PPIPER pPiper, ULONG ulCode, PSZ pszData);

typedef struct _PRINIT {
  PCHAR      pcPipes;
  /* List of named pipes to connect. Each name must be terminated with zero.
     Last name in list must be terminated with two zeros. */

  ULONG      ulReconnectPeriod;
  /* Period in msec. to reconnect to pipes listed in pcPipes. */

  PSZ        pszServerPipe;
  /* Name of server named pipe to send data received from client named pipe.
     May be NULL (do not create server named pipes). */

  ULONG      cServerPipes;
  /* Number of server named pipes pszServerPipe. I.e. maximum number of
     clients. May be zero (do not create server named pipes). */

  ULONG      ulWriteBufSize;
  ULONG      ulReadBufSize;

  PPRFNUSER  fnUser;
  /* User callback function. It will be triggered by events: the connection to
     the one of the named pipes (pcPipes) is established, the connection is
     broken, the line is received. May be NULL. */

} PRINIT, *PPRINIT;


// Returns PRRC_xxxxx.
ULONG prInit(PPIPER *ppPiper, PPRINIT pInit);

VOID prDone(PPIPER pPiper);

/* This function must be called periodically. This is where all the work for
   receiving and transmitting data is done.  */
VOID prProcess(PPIPER pPiper);

BOOL prIsConnected(PPIPER pPiper);

#endif // PIPER_H
